\documentclass[a4paper, trou]{tpl/ddpoly-en}
\usepackage{dirtree}
\usepackage{wasysym}
\usepackage{mathtools}
\usepackage{enumitem}
\setlist{nolistsep}

\input{macro}
\input{tpl/listing-config}

  
\graphicspath{{tpl/}{img/}}
\ddmodulename{Informatique}
\ddmodulenumber{Machine learning}
\ddauthor{D. André}
\dduniv{Ensil-Ensci}
\ddimg{\begin{center}\includegraphics[width=6cm]{img/arduino-logo}\end{center}}
\rien




\begin{document}
\renewcommand{\labelitemi}{$\bullet$}
\lstset{language=granCpp,style=granCpp}  
\lstset{language=granPython,style=granPython}  

\newdnnexo{01}{Build your Python environment}

\noindent The objective of this tutorial is to configure your Python
environment in order to follow this tutorial series on "dense neural networks from
scratch"?


\subsection*{Part 1: configuration using conda}

\begin{manip}
  Create in your "\texttt{P:}" directory, a "\texttt{dnn}" folder
  which will be your working directory.
\end{manip}

\begin{manip}
  Now, open the \textit{anaconda power shell prompt}" from the Windows menu
\end{manip}

\begin{manip}
  With the prompt, go to your working directory with the \texttt{cd} command 
  \vspace*{-1.5\baselineskip}
\begin{lstlisting}
(base) PS C:\Users\xxxxx> cd P:\dnn\
\end{lstlisting}
\end{manip}

\begin{manip}
  Create a virtual conda environment. Choose "\texttt{dnn}" as name for this environment:\\
\vspace*{-2.5\baselineskip}
\begin{lstlisting}
(base) PS P:\dnn> conda create -n dnn pip python=3.8
\end{lstlisting}
\end{manip}


\begin{manip}
  Activate your virtual conda environment \texttt{dnn}: 
  \vspace*{-1.5\baselineskip}
\begin{lstlisting}
(base) PS P:\dnn> conda activate dnn
\end{lstlisting}
\end{manip}

\begin{info}
  From now on, all the libraries that you will
  install via the \textbf{pip} tool will be available
  \textbf{only} in this virtual environment \texttt{(dnn)}.
\end{info}

\begin{manip}
  Download \href{https://gitlab.com/damien.andre/learning-python-for-science/blob/master/script/dnn/requirements.txt}{\texttt{requirements.txt}} file 
  and put it in your current working dir \keyw{\texttt{dnn}}. 
\end{manip}


\begin{manip}
  Install the libraries listed in the \texttt{requirements.txt} file
  with \textbf{pip}. You can type into the prompt:
  \vspace*{-1.5\baselineskip}
\begin{lstlisting}
(dnn) PS P:\dnn> pip install -r requirements.txt
\end{lstlisting}
\end{manip}

\begin{info}
  Great ! Your virtual conda environment \texttt{(dnn)}
  is ready for neural network!
\end{info}

\subsection*{Part 2: checking the environment}
Now, you have to check if your virtual conda environment \texttt{(dnn)}  works.

\begin{manip}
  Download the \href{https://gitlab.com/damien.andre/learning-python-for-science/blob/master/script/dnn/mltool.py}{\texttt{mltool.py}} file and put it in your current working dir \keyw{\texttt{dnn}}
\end{manip}

\begin{manip}
  Open the \textbf{thonny} python editor (or other one) by typing into the prompt:
  \vspace*{-1.5\baselineskip}
  \begin{lstlisting}
(dnn) PS P:\dnn> thonny
\end{lstlisting}
\end{manip}

\begin{manip}
  Save your current file in your current working directory \keyw{P:\textbackslash dnn}
\end{manip}


\begin{manip}
  In \textbf{thonny}, execute the following python script:
  \vspace*{-1.5\baselineskip}
\begin{lstlisting}
import numpy as np
from sklearn import datasets
from matplotlib import pyplot as plt
import mltool

# make randomized data
data,label = datasets.make_blobs(n_samples=1000, centers=2, n_features=2)

# plot data
plt.figure()
mltool.plot_region(data, label)
plt.show()
\end{lstlisting}
\end{manip}

\begin{info}
  Great, if you get the following chart, it means that you have successfully configured your Python environment!
  \begin{center}\includegraphics[width=.7\linewidth]{./img/mlmlxtend}\end{center}
\end{info}

\newpage

\subsection*{Part 3: summary of useful commands}

\textit{Open "\textit{anaconda power shell prompt}", and go in a working directory}
\vspace*{-1.6\baselineskip}
    \begin{lstlisting}
(base) PS C:\Users\xxxxxx> cd P:\dnn
\end{lstlisting}
\vspace*{-0.5\baselineskip}

\textit{Create virtual conda environment \texttt{(dnn)}}
\vspace*{-1.6\baselineskip}
    \begin{lstlisting}
(base) PS P:\dnn> conda create -n dnn pip python=3.8 
\end{lstlisting}
\vspace*{-0.5\baselineskip}

\textit{Activate virtual conda environment \texttt{(dnn)}}
\vspace*{-1.6\baselineskip}
    \begin{lstlisting}
(base) PS P:\dnn> conda activate dnn
\end{lstlisting}
\vspace*{-0.5\baselineskip}

\textit{Download the \href{https://gitlab.com/damien.andre/learning-python-for-science/blob/master/script/dnn/requirements.txt}{\texttt{requirements.txt}} file with the prompt}
\vspace*{-1.6\baselineskip}
    \begin{lstlisting}
(dnn) PS P:\dnn> Invoke-WebRequest -URI https://gitlab.com/damien.andre/learning-python-for-science/-/raw/master/script/dnn/requirements.txt -OutFile ./requirements.txt
\end{lstlisting}
\vspace*{-0.5\baselineskip}

\textit{Install the required libraries with \textbf{pip}}
\vspace*{-1.6\baselineskip}
    \begin{lstlisting}
(dnn) PS P:\dnn> pip install -r requirements.txt
\end{lstlisting}
\vspace*{-0.5\baselineskip}

\textit{Download the \href{https://gitlab.com/damien.andre/learning-python-for-science/blob/master/script/dnn/mltool.py}{\texttt{mltool.py}} with the prompt}
\vspace*{-1.6\baselineskip}
    \begin{lstlisting}
(dnn) PS P:\dnn> Invoke-WebRequest -URI https://gitlab.com/damien.andre/learning-python-for-science/-/raw/master/script/dnn/mltool.py -OutFile ./mltool.py
\end{lstlisting}
\vspace*{-0.5\baselineskip}

\textit{Execute thonny Python editor}
\vspace*{-1.6\baselineskip}
    \begin{lstlisting}
(dnn) PS P:\dnn> thonny
\end{lstlisting}


\end{document}
